import regex

begin_pattern = regex.compile(
    r'(?<!见\s*)(?<!与\s*)(?<!"\s*)(?<!“\s*)(?<!”\s*)'
    r'(?:投标人?|磋商|供应商|谈判供应商|磋商供应商)\s*须知正文\s*$',
    regex.MULTILINE
)


# 测试示例
test_strings = [
    '投标人须知正文',          # 匹配
    '”投标人须知正文',         # 不匹配
    '”  投标人须知正文',       # 不匹配
    '与 投标人须知正文',         # 不匹配
    '见 投标人须知正文',         # 不匹配
    '“ 投标人须知正文',         # 不匹配
    '供应商须知正文',          # 匹配
    '谈判供应商须知正文'         # 匹配
]

for s in test_strings:
    if begin_pattern.search(s):
        print(f"匹配: {s}")
    else:
        print(f"不匹配: {s}")
